#!/usr/bin/env python

import sys
import os.path
import pwd
import popen2
import string
import commands
import glob


try:
	import pygtk
	#tell pyGTK, if possible, that we want GTKv2
	pygtk.require("2.0")
except:
	#Some distributions come with GTK2, but not pyGTK
	pass
try:
	import gtk
	import gtk.glade
	import pango
	import gobject
except:
	print "You need to install pyGTK or GTKv2 and pyGtkSourceView",
	print "or set your PYTHONPATH correctly."
	print "try: export PYTHONPATH=",
	print "/usr/local/lib/python2.2/site-packages/"
	sys.exit(1)
#now we have both gtk and gtk.glade imported
#Also, we know we are running GTK v2

class BaseGui (gtk.glade.XML):
	def __init__ (self, windowname):
		gladefile = "/usr/share/convert_wav/glade/convert_wav.glade"
		gtk.glade.XML.__init__ (self, gladefile, windowname)
		self.widget = self.get_widget (windowname)
	
	def Show (self):
		self.widget.show ()

	def ActionDialogCloseHandler (self, widget, event):
		self.widget.hide ()
		return True

	def ActionCloseHandler (self, widget):
		self.widget.hide ()


class ProgressDialog (BaseGui):
	def __init__ (self):
		BaseGui.__init__ (self, "MainDialog")

		dic = { "ActionDialogClose" : gtk.main_quit, 
				  "ActionCancel" : self.ActionCancelHandler
				}

		self.signal_autoconnect (dic)
		self.stop = False
		self.progressbar = self.get_widget ("ProgressBar")
		self.title_tmpl = self.get_widget ("LabelTitle").get_label ()
		self.prog_tmpl = self.get_widget ("LabelProgress").get_label ()

	def ActionCancelHandler (self, widget):
		self.stop = True;
		gtk.main_quit ()

	def RunConvertion (self, file):
		self.get_widget ("ButtonClose").set_sensitive (False)
		self.get_widget ("LabelTitle").set_label (self.title_tmpl % ("WAV", "WAV", "MP3"))
		self.get_widget ("LabelProgress").set_label (self.prog_tmpl % ("Converting " + file + "..."))
		cmd = "lame -b 256 -m s \"" + file + "\""
		fp = popen2.Popen4(cmd)

		old_fraction = 0.0
		self.progressbar.set_fraction (0.0)
		self.progressbar.set_text ("0%")
		mode = "line"
		while not self.stop:
			if mode == "line":
				line = fp.fromchild.readline ()
			else:
				line = fp.fromchild.read (77)

			if line == "": break
			if line.find ("ETA") != -1:
				mode = "fixed" 
			if line.lower ().find ("average") != -1:
				mode = "line" 

			if mode == "fixed":
				progress = line[14:17]
				if progress[0] == '(':
					progress = progress[1:]
				if len (progress.strip ()) == 0:
					progress = 0
				fraction = float(progress) / 100.0

				if fraction != old_fraction:
					self.progressbar.set_fraction (fraction)
					self.progressbar.set_text (str(progress) + "%")
					while gtk.events_pending():
						gtk.main_iteration(False)
				old_fraction = fraction

		fp.wait ()
		self.get_widget ("LabelProgress").set_label (self.prog_tmpl % ("Convertion of " + file + " finished successfully."))
		self.get_widget ("ButtonClose").set_sensitive (True)


## MAIN ##
file = ""
if len (sys.argv) >= 2:
	app = ProgressDialog ()
	for file in sys.argv[1:]:
		app.RunConvertion (file)
gtk.main ()

# vim:ts=3:sw=3:tw=1024:ai
